<?php

/**
 * @file
 * Contains \Drupal\ji_quickbooks\Controller\MyPageController class.
 */

namespace Drupal\ji_quickbooks\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\RedirectResponse;
use \Drupal\Core\Url;

/**
 * Processes $_POST data from ji-quickbooks.joshideas.com.
 */
class OAuthResponseController extends ControllerBase {

  /**
   * Work around.
   *
   * Drupal 8 didn't accept $_POST data from the same form that
   * sent a redirect.  This is the only way I got it to work.
   */
  public function saveOAuthSettingsPage() {

    if (filter_input(INPUT_POST, 'realm_id')) {
      \Drupal::state()->set('ji_quickbooks_settings_realm_id', filter_input(INPUT_POST, 'realm_id'));

      // We just authenticated, mark when this occured so we can
      // auto-renew after five months, starting now.
      \Drupal::state()->set('ji_quickbooks_cron_started_on', REQUEST_TIME);
    }

    if (filter_input(INPUT_POST, 'oauth_token')) {
      \Drupal::state()->set('ji_quickbooks_settings_access_token', filter_input(INPUT_POST, 'oauth_token'));
    }

    if (filter_input(INPUT_POST, 'oauth_token_secret')) {
      \Drupal::state()->set('ji_quickbooks_settings_access_token_secret', filter_input(INPUT_POST, 'oauth_token_secret'));
    }

    if (filter_input(INPUT_POST, 'consumer_key')) {
      \Drupal::state()->set('ji_quickbooks_settings_consumer_key', filter_input(INPUT_POST, 'consumer_key'));
    }

    if (filter_input(INPUT_POST, 'consumer_secret')) {
      \Drupal::state()->set('ji_quickbooks_settings_consumer_secret', filter_input(INPUT_POST, 'consumer_secret'));
    }

    return new RedirectResponse(Url::fromRoute('ji_quickbooks.form')->toString());
  }

}
